import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:flutter/material.dart';
import 'package:hub/flutter_flow/flutter_flow_model.dart';
import 'package:hub/flutter_flow/nav/nav.dart';
import 'package:hub/shared/components/molecules/locals/index.dart';
import 'package:hub/shared/helpers/storage/base_storage.dart';
import 'package:hub/shared/helpers/storage/storage_helper.dart';

class LocalProfileEvent {
  
}

class LocalProfileState {
  final String cliName;
  final String cliUUID;

  LocalProfileState({this.cliName = '', this.cliUUID = ''});

  LocalProfileState copyWith({String? cliName, String? cliUUID}) {

    return LocalProfileState(
      cliName: cliName ?? this.cliName,
      cliUUID: cliUUID ?? this.cliUUID,
    );
  }
}

class LocalProfileBloc extends Bloc<LocalProfileEvent, LocalProfileState> {
  LocalProfileBloc() : super(LocalProfileState()) {
    on<LocalProfileEvent>(_onLocalProfileEvent);
  }

  Future<void> _onLocalProfileEvent(LocalProfileEvent event, Emitter<LocalProfileState> emit) async {
    final cliName = (await StorageHelper().get(KeychainStorageKey.clientName.value)) ?? '';
    final cliUUID = (await StorageHelper().get(KeychainStorageKey.clientUUID.value)) ?? '';
    emit(state.copyWith(cliName: cliName, cliUUID: cliUUID));
  }

  void updateProfile(BuildContext context) {
    add(LocalProfileEvent());
    LocalsRepositoryImpl().update(context);
  }
}

class LocalProfileComponentModel extends FlutterFlowModel<LocalProfileComponentWidget> {
  String cliName = '';
  String cliUUID = '';
  VoidCallback? setStateCallback;

  @override
  void initState(BuildContext context) {
    getData();
  }

  Future<void> getData() async {
    cliName = (await StorageHelper().get(KeychainStorageKey.clientName.value)) ?? '';
    cliUUID = (await StorageHelper().get(KeychainStorageKey.clientUUID.value)) ?? '';
    setStateCallback?.call();
  }

  @override
  void dispose() {}
}
